; DECLARE SUB W3D (BYVAL ZeroIfT5100%, BYVAL VideoBuffer%, BYVAL ForeGround%, BYVAL BackGround%, BYVAL TopSide%, BYVAL BottomSide%, BYVAL LeftSide%, BYVAL RightSide%)

DATA SEGMENT WORD PUBLIC 'DATA'
Ver db ?
UpRight db ?
Hor db 196
UpLeft db 218
DownLeft db 192
DownRight db 217
DATA ENDS
DGROUP GROUP DATA
CODE SEGMENT BYTE PUBLIC 'CODE'
ASSUME CS:CODE, DS:DGROUP
PUBLIC W3D
W3D PROC FAR
PUSH BP
MOV BP, SP
        pushf
        push ds
        push es
        push si
        push di
push ds

cld
mov Ver, 179
mov UpRight, 191
MOV ES, [BP+18]
MOV DX, [BP+10]
        inc dx
MOV BX, [BP+12]
        inc bx
SUB DX, BX
MOV CX, DX
INC CX
MOV SI, BX
MOV BX, [BP+8]
        inc bx
MOV DX, [BP+6]
        inc dx
SUB DX, BX
INC DX
DarkLines:
PUSH CX
MOV CX, DX
PUSH DX
PUSH BX
MOV AX, SI
DEC AX
DEC BX
ADD BX, BX
MOV DX, 160
MUL DX
ADD AX, BX
ADD AX, 1
MOV DI, AX
POP BX
POP DX
DarkColumns:
MOV AH, BYTE PTR ES:[DI]
AND AH, 15

        cmp word ptr [BP+20], 0
        jne Colour
        ;T5100 s.
        CMP AH, 0
        jnz NotBlack
        MOV AL, 0
        JMP short Confirm2
NotBlack:
        CMP AH, 6
        JA Next1
        MOV AL, 1
        JMP short Confirm2
Next1:
        MOV AL, 4
Confirm2:
        jmp short Pxhay
        ;T5100 e.
Colour:
        ;Colour Screen s.
        CMP AH, 0
        jnz NotBlack2
        MOV AL, 0
        JMP short Confirm3
NotBlack2:
        CMP AH, 6
        JAE NextWhite
        CMP AH, 4
        JAE NextDull
        MOV AL, 1
        JMP short Confirm3
NextWhite:
        MOV AL, 8
        JMP short Confirm3
NextDull:
        MOV AL, 4
        JMP short Confirm3
Confirm3:
        ;Colour Screen e.

Pxhay:
STOSB
INC DI
LOOP DarkColumns
INC SI
POP CX
LOOP DarkLines

MOV ES, [BP+18]
MOV DX, [BP+10]
MOV BX, [BP+12]
SUB DX, BX
MOV CX, DX
INC CX
MOV SI, BX
MOV BX, [BP+8]
MOV DX, [BP+6]
SUB DX, BX
INC DX
DarkLines2:
PUSH CX           ; Height.
MOV CX, DX
PUSH DX           ; Width.
PUSH BX           ; LeftSide.
MOV AX, SI        ; TopSide ++.
DEC AX
DEC BX
ADD BX, BX
MOV DX, 160
MUL DX
ADD AX, BX
MOV DI, AX
POP BX
POP DX
DarkColumns2:
        ; Care about CX, DX, SI, BX.
        ; cx=Width to 1
        ; si=TopSide to BottomSide
                        mov ah, [bp+14]
                        push cx
                        mov cl, 4
                        shl ah, cl
                        pop cx
        cmp si, [bp+12]
        jz GoToFirstBlot
        push si
        dec si
        cmp si, [bp+12]
        pop si
        jz GoToSecondBlot
        cmp si, [bp+10]
        ;jz GoToBottom
        jnz OutGoToBottom
        jmp GoToBottom
        OutGoToBottom:
        push si
        inc si
        cmp si, [bp+10]
        pop si
        ;jz GoToAboveBottom
        jnz OutGoToAboveBottom
        jmp GoToAboveBottom
        OutGoToAboveBottom:
        ; Ver Hor UpLeft UpRight DownLeft DownRight
                cmp cx, dx
                jz FirstColumn
                cmp cx, 1
                jz LastColumn
                cmp cx, 2
                jz BeforeLastColumn
                push dx
                dec dx
                cmp cx, dx
                pop dx
                jz SecondColumn
                        mov al, 32
                        add ah, [bp+16]
                jmp short FinishWithColumns
                FirstColumn:
                        mov al, Ver
                        add ah, 7
                jmp short FinishWithColumns
                SecondColumn:
                        mov al, Ver
                        add ah, [bp+16]
                jmp short FinishWithColumns
                BeforeLastColumn:
                        mov al, Ver
                        add ah, 7
                jmp short FinishWithColumns
                LastColumn:
                        mov al, Ver
                        add ah, [bp+16]
                FinishWithColumns:
        jmp Confirm
        GoToFirstBlot:
                cmp cx, dx
                jz FirstColumn2
                cmp cx, 1
                jz LastColumn2
                        mov al, Hor
                        add ah, 7
                jmp short FinishWithColumns2
                FirstColumn2:
                        mov al, UpLeft
                        add ah, 7
                jmp short FinishWithColumns2
                LastColumn2:
                        mov al, UpRight
                        add ah, [bp+16]
                FinishWithColumns2:
        jmp Confirm
        GoToSecondBlot:
                cmp cx, dx
                jz FirstColumn4
                cmp cx, 1
                jz LastColumn4
                cmp cx, 2
                jz BeforeLastColumn4
                push dx
                dec dx
                cmp cx, dx
                pop dx
                jz SecondColumn4
                        mov al, Hor
                        add ah, [bp+16]
                jmp short FinishWithColumns4
                FirstColumn4:
                        mov al, Ver
                        add ah, 7
                jmp short FinishWithColumns4
                SecondColumn4:
                        mov al, UpLeft
                        add ah, [bp+16]
                jmp short FinishWithColumns4
                BeforeLastColumn4:
                        mov al, UpRight
                        add ah, 7
                jmp short FinishWithColumns4
                LastColumn4:
                        mov al, Ver
                        add ah, [bp+16]
                FinishWithColumns4:
        jmp short Confirm
        GoToAboveBottom:
                cmp cx, dx
                jz FirstColumn5
                cmp cx, 1
                jz LastColumn5
                cmp cx, 2
                jz BeforeLastColumn5
                push dx
                dec dx
                cmp cx, dx
                pop dx
                jz SecondColumn5
                        mov al, Hor
                        add ah, 7
                jmp short FinishWithColumns5
                FirstColumn5:
                        mov al, Ver
                        add ah, 7
                jmp short FinishWithColumns5
                SecondColumn5:
                        mov al, DownLeft
                        add ah, [bp+16]
                jmp short FinishWithColumns5
                BeforeLastColumn5:
                        mov al, DownRight
                        add ah, 7
                jmp short FinishWithColumns5
                LastColumn5:
                        mov al, Ver
                        add ah, [bp+16]
                FinishWithColumns5:
        jmp short Confirm
        GoToBottom:
                cmp cx, dx
                jz FirstColumn3
                cmp cx, 1
                jz LastColumn3
                        mov al, Hor
                        add ah, [bp+16]
                jmp short FinishWithColumns3
                FirstColumn3:
                        mov al, DownLeft
                        add ah, 7
                jmp short FinishWithColumns3
                LastColumn3:
                        mov al, DownRight
                        add ah, [bp+16]
                FinishWithColumns3:
        Confirm:
        STOSW
;LOOP DarkColumns2
dec cx
cmp cx, 0
jz OutOfDarkColumns2
jmp DarkColumns2
OutOfDarkColumns2:
INC SI
POP CX
;LOOP DarkLines2
dec cx
cmp cx, 0
jz OutOfDarkLines2
jmp DarkLines2
OutOfDarkLines2:

pop ds
        pop di
        pop si
        pop es
        pop ds
        popf
POP BP
RET 16
W3D ENDP
CODE ENDS
END

;DEFINT A-Z
;SUB DrawFrame (Status, TopSide, BottomSide, LeftSide, RightSide, ForeGround, BackGround)
;Tiller$ = CHR$(32)
;IF (Status = -1) OR (Status = -2) OR (Status = -7) THEN
;   CALL SetGray(TopSide + 1, BottomSide + 1, LeftSide + 1, RightSide + 1)
;END IF
;TableFlag = CurrentFont
;SELECT CASE ABS(Status)
;CASE 1
;IF TableFlag = 1 THEN
;   LeftVer = 211: UpHor = 196: RightVer = 211: DownHor = 196
;   UpLeft = 218: UpRight = 207: DownLeft = 192: DownRight = 217
;ELSE
;   LeftVer = 179: UpHor = 196: RightVer = 179: DownHor = 196
;   UpLeft = 218: UpRight = 191: DownLeft = 192: DownRight = 217
;END IF
;CASE 2
;IF TableFlag = 1 THEN
;   LeftVer = 199: UpHor = 205: RightVer = 199: DownHor = 205
;   UpLeft = 201: UpRight = 215: DownLeft = 200: DownRight = 216
;ELSE
;   LeftVer = 186: UpHor = 205: RightVer = 186: DownHor = 205
;   UpLeft = 201: UpRight = 187: DownLeft = 200: DownRight = 188
;END IF
;CASE 7
;   LeftVer = 32: UpHor = 32: RightVer = 32: DownHor = 32
;   UpLeft = 32: UpRight = 32: DownLeft = 32: DownRight = 32
;END SELECT
;GOSUB Drawing
;EXIT SUB
;Drawing:
;FrameWidth = RightSide - LeftSide - 1
;Stupid = (BottomSide - TopSide) \ 2
;Spaces$ = CHR$(LeftVer) + STRING$(FrameWidth, Tiller$) + CHR$(RightVer)
;CALL ShadowPrint(TopSide, LeftSide, ForeGround, BackGround, CHR$(UpLeft) + STRING$(FrameWidth, DownHor) + CHR$(UpRight))
;CALL ShadowPrint(BottomSide, LeftSide, ForeGround, BackGround, CHR$(DownLeft) + STRING$(FrameWidth, UpHor) + CHR$(DownRight))
;FOR Row = 1 TO Stupid
;CALL ShadowPrint(TopSide + Row, LeftSide, ForeGround, BackGround, Spaces$)
;CALL ShadowPrint(BottomSide - Row, LeftSide, ForeGround, BackGround, Spaces$)
;NEXT Row
;RETURN
;END SUB

;DEFINT A-Z
;SUB InformationBox (UpperX, DownX, LeftY, RightY, ForeGround, BackGround)
;ExtraLight = 7
;TableFlag = CurrentFont
;IF TableFlag = 1 THEN
;   Ver = 211: Hor = 196
;   UpLeft = 218: UpRight = 207: DownLeft = 192: DownRight = 217
;ELSE
;   Ver = 179: Hor = 196
;   UpLeft = 218: UpRight = 191: DownLeft = 192: DownRight = 217
;END IF
;   DrawFrame -1, UpperX, DownX, LeftY, RightY, ForeGround, BackGround
;   DrawFrame 1, UpperX + 1, DownX - 1, LeftY + 1, RightY - 1, ForeGround, BackGround
;   CALL ShadowPrint(UpperX, LeftY, ExtraLight, BackGround, CHR$(UpLeft))
;   CALL ShadowPrint(UpperX, LeftY + 1, ExtraLight, BackGround, STRING$(RightY - LeftY - 1, CHR$(Hor)))
;   FOR i = UpperX + 1 TO DownX - 1
;   CALL ShadowPrint(i, LeftY, ExtraLight, BackGround, CHR$(Ver))
;   NEXT
;   CALL ShadowPrint(DownX, LeftY, ExtraLight, BackGround, CHR$(DownLeft))
;   CALL ShadowPrint(UpperX + 1, RightY - 1, ExtraLight, BackGround, CHR$(UpRight))
;   FOR i = UpperX + 2 TO DownX - 1
;   CALL ShadowPrint(i, RightY - 1, ExtraLight, BackGround, CHR$(Ver))
;   NEXT
;   CALL ShadowPrint(DownX - 1, RightY - 1, ExtraLight, BackGround, CHR$(DownRight))
;   CALL ShadowPrint(DownX - 1, LeftY + 2, ExtraLight, BackGround, STRING$(RightY - 1 - (LeftY + 1) - 1, CHR$(Hor)))
;END SUB

